/* 
 * Immunizations API
 *
 * The WI Department of Public Instruction in conjunction with the WI Department of Health Services is working to facilitate the retrieval of HL7 immunization data from the WI Immunization Registry via the EdFi API.
 *
 * OpenAPI spec version: v1
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using RestSharp.Portable;
using EdFi.OdsApi.Sdk.Client;
using EdFi.OdsApi.Sdk.Models.Immunizations;

namespace EdFi.OdsApi.Sdk.Api.Immunizations
{
    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
    public interface IImmunizationsApi : IApiAccessor
    {
        #region Synchronous Operations
        /// <summary>
        /// Returns a set of immunization history for a student
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="EdFi.OdsApi.Sdk.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="uniqueId">Unique Id of the person to be retrieved.</param>
        /// <returns>ImmunizationsStudentResponse</returns>
        ImmunizationsStudentResponse ImmunizationsStudentsUniqueIdGet (string uniqueId);

        /// <summary>
        /// Returns a set of immunization history for a student
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="EdFi.OdsApi.Sdk.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="uniqueId">Unique Id of the person to be retrieved.</param>
        /// <returns>ApiResponse of ImmunizationsStudentResponse</returns>
        ApiResponse<ImmunizationsStudentResponse> ImmunizationsStudentsUniqueIdGetWithHttpInfo (string uniqueId);
        #endregion Synchronous Operations
        #region Asynchronous Operations
        /// <summary>
        /// Returns a set of immunization history for a student
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="EdFi.OdsApi.Sdk.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="uniqueId">Unique Id of the person to be retrieved.</param>
        /// <returns>Task of ImmunizationsStudentResponse</returns>
        System.Threading.Tasks.Task<ImmunizationsStudentResponse> ImmunizationsStudentsUniqueIdGetAsync (string uniqueId);

        /// <summary>
        /// Returns a set of immunization history for a student
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="EdFi.OdsApi.Sdk.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="uniqueId">Unique Id of the person to be retrieved.</param>
        /// <returns>Task of ApiResponse (ImmunizationsStudentResponse)</returns>
        System.Threading.Tasks.Task<ApiResponse<ImmunizationsStudentResponse>> ImmunizationsStudentsUniqueIdGetAsyncWithHttpInfo (string uniqueId);
        #endregion Asynchronous Operations
    }

    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
    public partial class ImmunizationsApi : IImmunizationsApi
    {
        private EdFi.OdsApi.Sdk.Client.ExceptionFactory _exceptionFactory = (name, response) => null;

        /// <summary>
        /// Initializes a new instance of the <see cref="ImmunizationsApi"/> class.
        /// </summary>
        /// <returns></returns>
        public ImmunizationsApi(String basePath)
        {
            this.Configuration = new EdFi.OdsApi.Sdk.Client.Configuration { BasePath = basePath };

            ExceptionFactory = EdFi.OdsApi.Sdk.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="ImmunizationsApi"/> class
        /// using Configuration object
        /// </summary>
        /// <param name="configuration">An instance of Configuration</param>
        /// <returns></returns>
        public ImmunizationsApi(EdFi.OdsApi.Sdk.Client.Configuration configuration = null)
        {
            if (configuration == null) // use the default one in Configuration
                this.Configuration = EdFi.OdsApi.Sdk.Client.Configuration.Default;
            else
                this.Configuration = configuration;

            ExceptionFactory = EdFi.OdsApi.Sdk.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Gets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        public String GetBasePath()
        {
            return this.Configuration.ApiClient.RestClient.BaseUrl.ToString();
        }

        /// <summary>
        /// Sets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        [Obsolete("SetBasePath is deprecated, please do 'Configuration.ApiClient = new ApiClient(\"http://new-path\")' instead.")]
        public void SetBasePath(String basePath)
        {
            // do nothing
        }

        /// <summary>
        /// Gets or sets the configuration object
        /// </summary>
        /// <value>An instance of the Configuration</value>
        public EdFi.OdsApi.Sdk.Client.Configuration Configuration {get; set;}

        /// <summary>
        /// Provides a factory method hook for the creation of exceptions.
        /// </summary>
        public EdFi.OdsApi.Sdk.Client.ExceptionFactory ExceptionFactory
        {
            get
            {
                if (_exceptionFactory != null && _exceptionFactory.GetInvocationList().Length > 1)
                {
                    throw new InvalidOperationException("Multicast delegate for ExceptionFactory is unsupported.");
                }
                return _exceptionFactory;
            }
            set { _exceptionFactory = value; }
        }

        /// <summary>
        /// Gets the default header.
        /// </summary>
        /// <returns>Dictionary of HTTP header</returns>
        [Obsolete("DefaultHeader is deprecated, please use Configuration.DefaultHeader instead.")]
        public IDictionary<String, String> DefaultHeader()
        {
            return new ReadOnlyDictionary<string, string>(this.Configuration.DefaultHeader);
        }

        /// <summary>
        /// Add default header.
        /// </summary>
        /// <param name="key">Header field name.</param>
        /// <param name="value">Header field value.</param>
        /// <returns></returns>
        [Obsolete("AddDefaultHeader is deprecated, please use Configuration.AddDefaultHeader instead.")]
        public void AddDefaultHeader(string key, string value)
        {
            this.Configuration.AddDefaultHeader(key, value);
        }

        /// <summary>
        /// Returns a set of immunization history for a student 
        /// </summary>
        /// <exception cref="EdFi.OdsApi.Sdk.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="uniqueId">Unique Id of the person to be retrieved.</param>
        /// <returns>ImmunizationsStudentResponse</returns>
        public ImmunizationsStudentResponse ImmunizationsStudentsUniqueIdGet (string uniqueId)
        {
             ApiResponse<ImmunizationsStudentResponse> localVarResponse = ImmunizationsStudentsUniqueIdGetWithHttpInfo(uniqueId);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Returns a set of immunization history for a student 
        /// </summary>
        /// <exception cref="EdFi.OdsApi.Sdk.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="uniqueId">Unique Id of the person to be retrieved.</param>
        /// <returns>ApiResponse of ImmunizationsStudentResponse</returns>
        public ApiResponse< ImmunizationsStudentResponse > ImmunizationsStudentsUniqueIdGetWithHttpInfo (string uniqueId)
        {
            // verify the required parameter 'uniqueId' is set
            if (uniqueId == null)
                throw new ApiException(400, "Missing required parameter 'uniqueId' when calling ImmunizationsApi->ImmunizationsStudentsUniqueIdGet");

            var localVarPath = "./immunizations/students/{uniqueId}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (uniqueId != null) localVarPathParams.Add("uniqueId", this.Configuration.ApiClient.ParameterToString(uniqueId)); // path parameter

            // authentication (oauth2_client_credentials) required
            // oauth required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("ImmunizationsStudentsUniqueIdGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ImmunizationsStudentResponse>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Key, x => x.Value.ToString()),
                (ImmunizationsStudentResponse) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(ImmunizationsStudentResponse)));
        }

        /// <summary>
        /// Returns a set of immunization history for a student 
        /// </summary>
        /// <exception cref="EdFi.OdsApi.Sdk.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="uniqueId">Unique Id of the person to be retrieved.</param>
        /// <returns>Task of ImmunizationsStudentResponse</returns>
        public async System.Threading.Tasks.Task<ImmunizationsStudentResponse> ImmunizationsStudentsUniqueIdGetAsync (string uniqueId)
        {
             ApiResponse<ImmunizationsStudentResponse> localVarResponse = await ImmunizationsStudentsUniqueIdGetAsyncWithHttpInfo(uniqueId);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Returns a set of immunization history for a student 
        /// </summary>
        /// <exception cref="EdFi.OdsApi.Sdk.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="uniqueId">Unique Id of the person to be retrieved.</param>
        /// <returns>Task of ApiResponse (ImmunizationsStudentResponse)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<ImmunizationsStudentResponse>> ImmunizationsStudentsUniqueIdGetAsyncWithHttpInfo (string uniqueId)
        {
            // verify the required parameter 'uniqueId' is set
            if (uniqueId == null)
                throw new ApiException(400, "Missing required parameter 'uniqueId' when calling ImmunizationsApi->ImmunizationsStudentsUniqueIdGet");

            var localVarPath = "./immunizations/students/{uniqueId}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (uniqueId != null) localVarPathParams.Add("uniqueId", this.Configuration.ApiClient.ParameterToString(uniqueId)); // path parameter

            // authentication (oauth2_client_credentials) required
            // oauth required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("ImmunizationsStudentsUniqueIdGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ImmunizationsStudentResponse>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Key, x => x.Value.ToString()),
                (ImmunizationsStudentResponse) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(ImmunizationsStudentResponse)));
        }

    }
}
