/* 
 * Available Change Versions API Endpoint
 *
 * The Ed-Fi ODS / API enables applications to read and write education data stored in an Ed-Fi ODS through a secure REST interface.  ***  > *Note: Consumers of ODS / API information should sanitize all data for display and storage. The ODS / API provides reasonable safeguards against cross-site scripting attacks and other malicious content, but the platform does not and cannot guarantee that the data it contains is free of all potentially harmful content.*  *** 
 *
 * OpenAPI spec version: 1.0.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using SwaggerDateConverter = EdFi.OdsApi.Sdk.Client.SwaggerDateConverter;

namespace EdFi.OdsApi.Sdk.Models.ChangeQueries
{
    /// <summary>
    /// AvailableChangeVersion
    /// </summary>
    [DataContract]
    public partial class AvailableChangeVersion :  IEquatable<AvailableChangeVersion>
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="AvailableChangeVersion" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected AvailableChangeVersion() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="AvailableChangeVersion" /> class.
        /// </summary>
        /// <param name="oldestChangeVersion">oldestChangeVersion (required).</param>
        /// <param name="newestChangeVersion">newestChangeVersion (required).</param>
        public AvailableChangeVersion(long? oldestChangeVersion = default(long?), long? newestChangeVersion = default(long?))
        {
            // to ensure "oldestChangeVersion" is required (not null)
            if (oldestChangeVersion == null)
            {
                throw new InvalidDataException("oldestChangeVersion is a required property for AvailableChangeVersion and cannot be null");
            }
            else
            {
                this.OldestChangeVersion = oldestChangeVersion;
            }
            // to ensure "newestChangeVersion" is required (not null)
            if (newestChangeVersion == null)
            {
                throw new InvalidDataException("newestChangeVersion is a required property for AvailableChangeVersion and cannot be null");
            }
            else
            {
                this.NewestChangeVersion = newestChangeVersion;
            }
        }
        
        /// <summary>
        /// Gets or Sets OldestChangeVersion
        /// </summary>
        [DataMember(Name="OldestChangeVersion", EmitDefaultValue=false)]
        public long? OldestChangeVersion { get; set; }

        /// <summary>
        /// Gets or Sets NewestChangeVersion
        /// </summary>
        [DataMember(Name="NewestChangeVersion", EmitDefaultValue=false)]
        public long? NewestChangeVersion { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class AvailableChangeVersion {\n");
            sb.Append("  OldestChangeVersion: ").Append(OldestChangeVersion).Append("\n");
            sb.Append("  NewestChangeVersion: ").Append(NewestChangeVersion).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as AvailableChangeVersion);
        }

        /// <summary>
        /// Returns true if AvailableChangeVersion instances are equal
        /// </summary>
        /// <param name="input">Instance of AvailableChangeVersion to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(AvailableChangeVersion input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.OldestChangeVersion == input.OldestChangeVersion ||
                    (this.OldestChangeVersion != null &&
                    this.OldestChangeVersion.Equals(input.OldestChangeVersion))
                ) && 
                (
                    this.NewestChangeVersion == input.NewestChangeVersion ||
                    (this.NewestChangeVersion != null &&
                    this.NewestChangeVersion.Equals(input.NewestChangeVersion))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.OldestChangeVersion != null)
                    hashCode = hashCode * 59 + this.OldestChangeVersion.GetHashCode();
                if (this.NewestChangeVersion != null)
                    hashCode = hashCode * 59 + this.NewestChangeVersion.GetHashCode();
                return hashCode;
            }
        }
    }

}
