/* 
 * Ed-Fi Operational Data Store API
 *
 * The Ed-Fi ODS / API enables applications to read and write education data stored in an Ed-Fi ODS through a secure REST interface.  ***  > *Note: Consumers of ODS / API information should sanitize all data for display and storage. The ODS / API provides reasonable safeguards against cross-site scripting attacks and other malicious content, but the platform does not and cannot guarantee that the data it contains is free of all potentially harmful content.*  *** 
 *
 * OpenAPI spec version: 3
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using SwaggerDateConverter = EdFi.OdsApi.Sdk.Client.SwaggerDateConverter;

namespace EdFi.OdsApi.Sdk.Models.EnrollmentComposites
{
    /// <summary>
    /// StaffStaffEducationOrganizationAssignmentAssociation
    /// </summary>
    [DataContract]
    public partial class StaffStaffEducationOrganizationAssignmentAssociation :  IEquatable<StaffStaffEducationOrganizationAssignmentAssociation>
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="StaffStaffEducationOrganizationAssignmentAssociation" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected StaffStaffEducationOrganizationAssignmentAssociation() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="StaffStaffEducationOrganizationAssignmentAssociation" /> class.
        /// </summary>
        /// <param name="staffClassificationDescriptor">The titles of employment, official status, or rank of education staff. (required).</param>
        /// <param name="educationOrganizationType">educationOrganizationType.</param>
        /// <param name="educationOrganizationId">The identifier assigned to an education organization. (required).</param>
        public StaffStaffEducationOrganizationAssignmentAssociation(string staffClassificationDescriptor = default(string), string educationOrganizationType = default(string), int? educationOrganizationId = default(int?))
        {
            // to ensure "staffClassificationDescriptor" is required (not null)
            if (staffClassificationDescriptor == null)
            {
                throw new InvalidDataException("staffClassificationDescriptor is a required property for StaffStaffEducationOrganizationAssignmentAssociation and cannot be null");
            }
            else
            {
                this.StaffClassificationDescriptor = staffClassificationDescriptor;
            }
            // to ensure "educationOrganizationId" is required (not null)
            if (educationOrganizationId == null)
            {
                throw new InvalidDataException("educationOrganizationId is a required property for StaffStaffEducationOrganizationAssignmentAssociation and cannot be null");
            }
            else
            {
                this.EducationOrganizationId = educationOrganizationId;
            }
            this.EducationOrganizationType = educationOrganizationType;
        }
        
        /// <summary>
        /// The titles of employment, official status, or rank of education staff.
        /// </summary>
        /// <value>The titles of employment, official status, or rank of education staff.</value>
        [DataMember(Name="staffClassificationDescriptor", EmitDefaultValue=false)]
        public string StaffClassificationDescriptor { get; set; }

        /// <summary>
        /// Gets or Sets EducationOrganizationType
        /// </summary>
        [DataMember(Name="educationOrganizationType", EmitDefaultValue=false)]
        public string EducationOrganizationType { get; set; }

        /// <summary>
        /// The identifier assigned to an education organization.
        /// </summary>
        /// <value>The identifier assigned to an education organization.</value>
        [DataMember(Name="educationOrganizationId", EmitDefaultValue=false)]
        public int? EducationOrganizationId { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class StaffStaffEducationOrganizationAssignmentAssociation {\n");
            sb.Append("  StaffClassificationDescriptor: ").Append(StaffClassificationDescriptor).Append("\n");
            sb.Append("  EducationOrganizationType: ").Append(EducationOrganizationType).Append("\n");
            sb.Append("  EducationOrganizationId: ").Append(EducationOrganizationId).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as StaffStaffEducationOrganizationAssignmentAssociation);
        }

        /// <summary>
        /// Returns true if StaffStaffEducationOrganizationAssignmentAssociation instances are equal
        /// </summary>
        /// <param name="input">Instance of StaffStaffEducationOrganizationAssignmentAssociation to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(StaffStaffEducationOrganizationAssignmentAssociation input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.StaffClassificationDescriptor == input.StaffClassificationDescriptor ||
                    (this.StaffClassificationDescriptor != null &&
                    this.StaffClassificationDescriptor.Equals(input.StaffClassificationDescriptor))
                ) && 
                (
                    this.EducationOrganizationType == input.EducationOrganizationType ||
                    (this.EducationOrganizationType != null &&
                    this.EducationOrganizationType.Equals(input.EducationOrganizationType))
                ) && 
                (
                    this.EducationOrganizationId == input.EducationOrganizationId ||
                    (this.EducationOrganizationId != null &&
                    this.EducationOrganizationId.Equals(input.EducationOrganizationId))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.StaffClassificationDescriptor != null)
                    hashCode = hashCode * 59 + this.StaffClassificationDescriptor.GetHashCode();
                if (this.EducationOrganizationType != null)
                    hashCode = hashCode * 59 + this.EducationOrganizationType.GetHashCode();
                if (this.EducationOrganizationId != null)
                    hashCode = hashCode * 59 + this.EducationOrganizationId.GetHashCode();
                return hashCode;
            }
        }
    }

}
