/* 
 * Immunizations API
 *
 * The WI Department of Public Instruction in conjunction with the WI Department of Health Services is working to facilitate the retrieval of HL7 immunization data from the WI Immunization Registry via the EdFi API.
 *
 * OpenAPI spec version: v1
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using SwaggerDateConverter = EdFi.OdsApi.Sdk.Client.SwaggerDateConverter;

namespace EdFi.OdsApi.Sdk.Models.Immunizations
{
    /// <summary>
    /// The student identifiers and the student immunization history.
    /// </summary>
    [DataContract]
    public partial class ImmunizationsStudentHistory :  IEquatable<ImmunizationsStudentHistory>
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ImmunizationsStudentHistory" /> class.
        /// </summary>
        /// <param name="patientIdentifier">patientIdentifier.</param>
        /// <param name="studentReference">studentReference.</param>
        /// <param name="studentEducationOrganizationAssociationReference">studentEducationOrganizationAssociationReference.</param>
        /// <param name="pharmacyTreatmentAdministrations">An array of the student immunization history..</param>
        public ImmunizationsStudentHistory(ImmunizationsPatientIdentifier patientIdentifier = default(ImmunizationsPatientIdentifier), StudentReference studentReference = default(StudentReference), StudentEducationOrganizationAssociationReference studentEducationOrganizationAssociationReference = default(StudentEducationOrganizationAssociationReference), List<ImmunizationsPharmacyTreatmentAdministration> pharmacyTreatmentAdministrations = default(List<ImmunizationsPharmacyTreatmentAdministration>))
        {
            this.PatientIdentifier = patientIdentifier;
            this.StudentReference = studentReference;
            this.StudentEducationOrganizationAssociationReference = studentEducationOrganizationAssociationReference;
            this.PharmacyTreatmentAdministrations = pharmacyTreatmentAdministrations;
        }
        
        /// <summary>
        /// Gets or Sets PatientIdentifier
        /// </summary>
        [DataMember(Name="patientIdentifier", EmitDefaultValue=false)]
        public ImmunizationsPatientIdentifier PatientIdentifier { get; set; }

        /// <summary>
        /// Gets or Sets StudentReference
        /// </summary>
        [DataMember(Name="studentReference", EmitDefaultValue=false)]
        public StudentReference StudentReference { get; set; }

        /// <summary>
        /// Gets or Sets StudentEducationOrganizationAssociationReference
        /// </summary>
        [DataMember(Name="studentEducationOrganizationAssociationReference", EmitDefaultValue=false)]
        public StudentEducationOrganizationAssociationReference StudentEducationOrganizationAssociationReference { get; set; }

        /// <summary>
        /// An array of the student immunization history.
        /// </summary>
        /// <value>An array of the student immunization history.</value>
        [DataMember(Name="pharmacyTreatmentAdministrations", EmitDefaultValue=false)]
        public List<ImmunizationsPharmacyTreatmentAdministration> PharmacyTreatmentAdministrations { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ImmunizationsStudentHistory {\n");
            sb.Append("  PatientIdentifier: ").Append(PatientIdentifier).Append("\n");
            sb.Append("  StudentReference: ").Append(StudentReference).Append("\n");
            sb.Append("  StudentEducationOrganizationAssociationReference: ").Append(StudentEducationOrganizationAssociationReference).Append("\n");
            sb.Append("  PharmacyTreatmentAdministrations: ").Append(PharmacyTreatmentAdministrations).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ImmunizationsStudentHistory);
        }

        /// <summary>
        /// Returns true if ImmunizationsStudentHistory instances are equal
        /// </summary>
        /// <param name="input">Instance of ImmunizationsStudentHistory to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ImmunizationsStudentHistory input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.PatientIdentifier == input.PatientIdentifier ||
                    (this.PatientIdentifier != null &&
                    this.PatientIdentifier.Equals(input.PatientIdentifier))
                ) && 
                (
                    this.StudentReference == input.StudentReference ||
                    (this.StudentReference != null &&
                    this.StudentReference.Equals(input.StudentReference))
                ) && 
                (
                    this.StudentEducationOrganizationAssociationReference == input.StudentEducationOrganizationAssociationReference ||
                    (this.StudentEducationOrganizationAssociationReference != null &&
                    this.StudentEducationOrganizationAssociationReference.Equals(input.StudentEducationOrganizationAssociationReference))
                ) && 
                (
                    this.PharmacyTreatmentAdministrations == input.PharmacyTreatmentAdministrations ||
                    this.PharmacyTreatmentAdministrations != null &&
                    this.PharmacyTreatmentAdministrations.SequenceEqual(input.PharmacyTreatmentAdministrations)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.PatientIdentifier != null)
                    hashCode = hashCode * 59 + this.PatientIdentifier.GetHashCode();
                if (this.StudentReference != null)
                    hashCode = hashCode * 59 + this.StudentReference.GetHashCode();
                if (this.StudentEducationOrganizationAssociationReference != null)
                    hashCode = hashCode * 59 + this.StudentEducationOrganizationAssociationReference.GetHashCode();
                if (this.PharmacyTreatmentAdministrations != null)
                    hashCode = hashCode * 59 + this.PharmacyTreatmentAdministrations.GetHashCode();
                return hashCode;
            }
        }
    }

}
