/* 
 * Ed-Fi Operational Data Store API
 *
 * The Ed-Fi ODS / API enables applications to read and write education data stored in an Ed-Fi ODS through a secure REST interface.  ***  > *Note: Consumers of ODS / API information should sanitize all data for display and storage. The ODS / API provides reasonable safeguards against cross-site scripting attacks and other malicious content, but the platform does not and cannot guarantee that the data it contains is free of all potentially harmful content.*  *** 
 *
 * OpenAPI spec version: 3
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using SwaggerDateConverter = EdFi.OdsApi.Sdk.Client.SwaggerDateConverter;

namespace EdFi.OdsApi.Sdk.Models.Profiles.WiDpi.Public_Only_SPED
{
    /// <summary>
    /// EdFiStudentEducationOrganizationAssociationDisabilityDesignationReadable
    /// </summary>
    [DataContract]
    public partial class EdFiStudentEducationOrganizationAssociationDisabilityDesignationReadable :  IEquatable<EdFiStudentEducationOrganizationAssociationDisabilityDesignationReadable>
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="EdFiStudentEducationOrganizationAssociationDisabilityDesignationReadable" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected EdFiStudentEducationOrganizationAssociationDisabilityDesignationReadable() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="EdFiStudentEducationOrganizationAssociationDisabilityDesignationReadable" /> class.
        /// </summary>
        /// <param name="disabilityDesignationDescriptor">Whether the disability is IDEA, Section 504, or other disability designation. (required).</param>
        public EdFiStudentEducationOrganizationAssociationDisabilityDesignationReadable(string disabilityDesignationDescriptor = default(string))
        {
            // to ensure "disabilityDesignationDescriptor" is required (not null)
            if (disabilityDesignationDescriptor == null)
            {
                throw new InvalidDataException("disabilityDesignationDescriptor is a required property for EdFiStudentEducationOrganizationAssociationDisabilityDesignationReadable and cannot be null");
            }
            else
            {
                this.DisabilityDesignationDescriptor = disabilityDesignationDescriptor;
            }
        }
        
        /// <summary>
        /// Whether the disability is IDEA, Section 504, or other disability designation.
        /// </summary>
        /// <value>Whether the disability is IDEA, Section 504, or other disability designation.</value>
        [DataMember(Name="disabilityDesignationDescriptor", EmitDefaultValue=false)]
        public string DisabilityDesignationDescriptor { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class EdFiStudentEducationOrganizationAssociationDisabilityDesignationReadable {\n");
            sb.Append("  DisabilityDesignationDescriptor: ").Append(DisabilityDesignationDescriptor).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as EdFiStudentEducationOrganizationAssociationDisabilityDesignationReadable);
        }

        /// <summary>
        /// Returns true if EdFiStudentEducationOrganizationAssociationDisabilityDesignationReadable instances are equal
        /// </summary>
        /// <param name="input">Instance of EdFiStudentEducationOrganizationAssociationDisabilityDesignationReadable to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(EdFiStudentEducationOrganizationAssociationDisabilityDesignationReadable input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.DisabilityDesignationDescriptor == input.DisabilityDesignationDescriptor ||
                    (this.DisabilityDesignationDescriptor != null &&
                    this.DisabilityDesignationDescriptor.Equals(input.DisabilityDesignationDescriptor))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.DisabilityDesignationDescriptor != null)
                    hashCode = hashCode * 59 + this.DisabilityDesignationDescriptor.GetHashCode();
                return hashCode;
            }
        }
    }

}
