/* 
 * Ed-Fi Operational Data Store API
 *
 * The Ed-Fi ODS / API enables applications to read and write education data stored in an Ed-Fi ODS through a secure REST interface.  ***  > *Note: Consumers of ODS / API information should sanitize all data for display and storage. The ODS / API provides reasonable safeguards against cross-site scripting attacks and other malicious content, but the platform does not and cannot guarantee that the data it contains is free of all potentially harmful content.*  *** 
 *
 * OpenAPI spec version: 3
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using SwaggerDateConverter = EdFi.OdsApi.Sdk.Client.SwaggerDateConverter;

namespace EdFi.OdsApi.Sdk.Models.Resources
{
    /// <summary>
    /// EdFiDisciplineActionDiscipline
    /// </summary>
    [DataContract]
    public partial class EdFiDisciplineActionDiscipline :  IEquatable<EdFiDisciplineActionDiscipline>
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="EdFiDisciplineActionDiscipline" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected EdFiDisciplineActionDiscipline() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="EdFiDisciplineActionDiscipline" /> class.
        /// </summary>
        /// <param name="disciplineDescriptor">Type of action, such as removal from the classroom, used to discipline the student involved as a perpetrator in a discipline incident. (required).</param>
        public EdFiDisciplineActionDiscipline(string disciplineDescriptor = default(string))
        {
            // to ensure "disciplineDescriptor" is required (not null)
            if (disciplineDescriptor == null)
            {
                throw new InvalidDataException("disciplineDescriptor is a required property for EdFiDisciplineActionDiscipline and cannot be null");
            }
            else
            {
                this.DisciplineDescriptor = disciplineDescriptor;
            }
        }
        
        /// <summary>
        /// Type of action, such as removal from the classroom, used to discipline the student involved as a perpetrator in a discipline incident.
        /// </summary>
        /// <value>Type of action, such as removal from the classroom, used to discipline the student involved as a perpetrator in a discipline incident.</value>
        [DataMember(Name="disciplineDescriptor", EmitDefaultValue=false)]
        public string DisciplineDescriptor { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class EdFiDisciplineActionDiscipline {\n");
            sb.Append("  DisciplineDescriptor: ").Append(DisciplineDescriptor).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as EdFiDisciplineActionDiscipline);
        }

        /// <summary>
        /// Returns true if EdFiDisciplineActionDiscipline instances are equal
        /// </summary>
        /// <param name="input">Instance of EdFiDisciplineActionDiscipline to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(EdFiDisciplineActionDiscipline input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.DisciplineDescriptor == input.DisciplineDescriptor ||
                    (this.DisciplineDescriptor != null &&
                    this.DisciplineDescriptor.Equals(input.DisciplineDescriptor))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.DisciplineDescriptor != null)
                    hashCode = hashCode * 59 + this.DisciplineDescriptor.GetHashCode();
                return hashCode;
            }
        }
    }

}
