/* 
 * Ed-Fi Operational Data Store API
 *
 * The Ed-Fi ODS / API enables applications to read and write education data stored in an Ed-Fi ODS through a secure REST interface.  ***  > *Note: Consumers of ODS / API information should sanitize all data for display and storage. The ODS / API provides reasonable safeguards against cross-site scripting attacks and other malicious content, but the platform does not and cannot guarantee that the data it contains is free of all potentially harmful content.*  *** 
 *
 * OpenAPI spec version: 3
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using SwaggerDateConverter = EdFi.OdsApi.Sdk.Client.SwaggerDateConverter;

namespace EdFi.OdsApi.Sdk.Models.Resources
{
    /// <summary>
    /// EdFiDisciplineIncidentWeapon
    /// </summary>
    [DataContract]
    public partial class EdFiDisciplineIncidentWeapon :  IEquatable<EdFiDisciplineIncidentWeapon>
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="EdFiDisciplineIncidentWeapon" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected EdFiDisciplineIncidentWeapon() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="EdFiDisciplineIncidentWeapon" /> class.
        /// </summary>
        /// <param name="weaponDescriptor">Identifies the type of weapon used during an incident. The Federal Gun-Free Schools Act requires states to report the number of students expelled for bringing firearms to school by type of firearm. (required).</param>
        public EdFiDisciplineIncidentWeapon(string weaponDescriptor = default(string))
        {
            // to ensure "weaponDescriptor" is required (not null)
            if (weaponDescriptor == null)
            {
                throw new InvalidDataException("weaponDescriptor is a required property for EdFiDisciplineIncidentWeapon and cannot be null");
            }
            else
            {
                this.WeaponDescriptor = weaponDescriptor;
            }
        }
        
        /// <summary>
        /// Identifies the type of weapon used during an incident. The Federal Gun-Free Schools Act requires states to report the number of students expelled for bringing firearms to school by type of firearm.
        /// </summary>
        /// <value>Identifies the type of weapon used during an incident. The Federal Gun-Free Schools Act requires states to report the number of students expelled for bringing firearms to school by type of firearm.</value>
        [DataMember(Name="weaponDescriptor", EmitDefaultValue=false)]
        public string WeaponDescriptor { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class EdFiDisciplineIncidentWeapon {\n");
            sb.Append("  WeaponDescriptor: ").Append(WeaponDescriptor).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as EdFiDisciplineIncidentWeapon);
        }

        /// <summary>
        /// Returns true if EdFiDisciplineIncidentWeapon instances are equal
        /// </summary>
        /// <param name="input">Instance of EdFiDisciplineIncidentWeapon to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(EdFiDisciplineIncidentWeapon input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.WeaponDescriptor == input.WeaponDescriptor ||
                    (this.WeaponDescriptor != null &&
                    this.WeaponDescriptor.Equals(input.WeaponDescriptor))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.WeaponDescriptor != null)
                    hashCode = hashCode * 59 + this.WeaponDescriptor.GetHashCode();
                return hashCode;
            }
        }
    }

}
