/* 
 * Ed-Fi Operational Data Store API
 *
 * The Ed-Fi ODS / API enables applications to read and write education data stored in an Ed-Fi ODS through a secure REST interface.  ***  > *Note: Consumers of ODS / API information should sanitize all data for display and storage. The ODS / API provides reasonable safeguards against cross-site scripting attacks and other malicious content, but the platform does not and cannot guarantee that the data it contains is free of all potentially harmful content.*  *** 
 *
 * OpenAPI spec version: 3
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using SwaggerDateConverter = EdFi.OdsApi.Sdk.Client.SwaggerDateConverter;

namespace EdFi.OdsApi.Sdk.Models.Resources
{
    /// <summary>
    /// EdFiEducationContentReference
    /// </summary>
    [DataContract]
    public partial class EdFiEducationContentReference :  IEquatable<EdFiEducationContentReference>
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="EdFiEducationContentReference" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected EdFiEducationContentReference() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="EdFiEducationContentReference" /> class.
        /// </summary>
        /// <param name="contentIdentifier">A unique identifier for the EducationContent. (required).</param>
        /// <param name="link">link.</param>
        public EdFiEducationContentReference(string contentIdentifier = default(string), Link link = default(Link))
        {
            // to ensure "contentIdentifier" is required (not null)
            if (contentIdentifier == null)
            {
                throw new InvalidDataException("contentIdentifier is a required property for EdFiEducationContentReference and cannot be null");
            }
            else
            {
                this.ContentIdentifier = contentIdentifier;
            }
            this.Link = link;
        }
        
        /// <summary>
        /// A unique identifier for the EducationContent.
        /// </summary>
        /// <value>A unique identifier for the EducationContent.</value>
        [DataMember(Name="contentIdentifier", EmitDefaultValue=false)]
        public string ContentIdentifier { get; set; }

        /// <summary>
        /// Gets or Sets Link
        /// </summary>
        [DataMember(Name="link", EmitDefaultValue=false)]
        public Link Link { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class EdFiEducationContentReference {\n");
            sb.Append("  ContentIdentifier: ").Append(ContentIdentifier).Append("\n");
            sb.Append("  Link: ").Append(Link).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as EdFiEducationContentReference);
        }

        /// <summary>
        /// Returns true if EdFiEducationContentReference instances are equal
        /// </summary>
        /// <param name="input">Instance of EdFiEducationContentReference to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(EdFiEducationContentReference input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.ContentIdentifier == input.ContentIdentifier ||
                    (this.ContentIdentifier != null &&
                    this.ContentIdentifier.Equals(input.ContentIdentifier))
                ) && 
                (
                    this.Link == input.Link ||
                    (this.Link != null &&
                    this.Link.Equals(input.Link))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.ContentIdentifier != null)
                    hashCode = hashCode * 59 + this.ContentIdentifier.GetHashCode();
                if (this.Link != null)
                    hashCode = hashCode * 59 + this.Link.GetHashCode();
                return hashCode;
            }
        }
    }

}
