/* 
 * Ed-Fi Operational Data Store API
 *
 * The Ed-Fi ODS / API enables applications to read and write education data stored in an Ed-Fi ODS through a secure REST interface.  ***  > *Note: Consumers of ODS / API information should sanitize all data for display and storage. The ODS / API provides reasonable safeguards against cross-site scripting attacks and other malicious content, but the platform does not and cannot guarantee that the data it contains is free of all potentially harmful content.*  *** 
 *
 * OpenAPI spec version: 3
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using SwaggerDateConverter = EdFi.OdsApi.Sdk.Client.SwaggerDateConverter;

namespace EdFi.OdsApi.Sdk.Models.Resources
{
    /// <summary>
    /// EdFiInterventionPopulationServed
    /// </summary>
    [DataContract]
    public partial class EdFiInterventionPopulationServed :  IEquatable<EdFiInterventionPopulationServed>
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="EdFiInterventionPopulationServed" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected EdFiInterventionPopulationServed() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="EdFiInterventionPopulationServed" /> class.
        /// </summary>
        /// <param name="populationServedDescriptor">A subset of students that are the focus of the Intervention. (required).</param>
        public EdFiInterventionPopulationServed(string populationServedDescriptor = default(string))
        {
            // to ensure "populationServedDescriptor" is required (not null)
            if (populationServedDescriptor == null)
            {
                throw new InvalidDataException("populationServedDescriptor is a required property for EdFiInterventionPopulationServed and cannot be null");
            }
            else
            {
                this.PopulationServedDescriptor = populationServedDescriptor;
            }
        }
        
        /// <summary>
        /// A subset of students that are the focus of the Intervention.
        /// </summary>
        /// <value>A subset of students that are the focus of the Intervention.</value>
        [DataMember(Name="populationServedDescriptor", EmitDefaultValue=false)]
        public string PopulationServedDescriptor { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class EdFiInterventionPopulationServed {\n");
            sb.Append("  PopulationServedDescriptor: ").Append(PopulationServedDescriptor).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as EdFiInterventionPopulationServed);
        }

        /// <summary>
        /// Returns true if EdFiInterventionPopulationServed instances are equal
        /// </summary>
        /// <param name="input">Instance of EdFiInterventionPopulationServed to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(EdFiInterventionPopulationServed input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.PopulationServedDescriptor == input.PopulationServedDescriptor ||
                    (this.PopulationServedDescriptor != null &&
                    this.PopulationServedDescriptor.Equals(input.PopulationServedDescriptor))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.PopulationServedDescriptor != null)
                    hashCode = hashCode * 59 + this.PopulationServedDescriptor.GetHashCode();
                return hashCode;
            }
        }
    }

}
