/* 
 * Ed-Fi Operational Data Store API
 *
 * The Ed-Fi ODS / API enables applications to read and write education data stored in an Ed-Fi ODS through a secure REST interface.  ***  > *Note: Consumers of ODS / API information should sanitize all data for display and storage. The ODS / API provides reasonable safeguards against cross-site scripting attacks and other malicious content, but the platform does not and cannot guarantee that the data it contains is free of all potentially harmful content.*  *** 
 *
 * OpenAPI spec version: 3
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using SwaggerDateConverter = EdFi.OdsApi.Sdk.Client.SwaggerDateConverter;

namespace EdFi.OdsApi.Sdk.Models.Resources
{
    /// <summary>
    /// EdFiInterventionStudyStateAbbreviation
    /// </summary>
    [DataContract]
    public partial class EdFiInterventionStudyStateAbbreviation :  IEquatable<EdFiInterventionStudyStateAbbreviation>
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="EdFiInterventionStudyStateAbbreviation" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected EdFiInterventionStudyStateAbbreviation() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="EdFiInterventionStudyStateAbbreviation" /> class.
        /// </summary>
        /// <param name="stateAbbreviationDescriptor">The abbreviation for the state (within the United States) or outlying area, the school system of which the participants of the study are considered to be a part. (required).</param>
        public EdFiInterventionStudyStateAbbreviation(string stateAbbreviationDescriptor = default(string))
        {
            // to ensure "stateAbbreviationDescriptor" is required (not null)
            if (stateAbbreviationDescriptor == null)
            {
                throw new InvalidDataException("stateAbbreviationDescriptor is a required property for EdFiInterventionStudyStateAbbreviation and cannot be null");
            }
            else
            {
                this.StateAbbreviationDescriptor = stateAbbreviationDescriptor;
            }
        }
        
        /// <summary>
        /// The abbreviation for the state (within the United States) or outlying area, the school system of which the participants of the study are considered to be a part.
        /// </summary>
        /// <value>The abbreviation for the state (within the United States) or outlying area, the school system of which the participants of the study are considered to be a part.</value>
        [DataMember(Name="stateAbbreviationDescriptor", EmitDefaultValue=false)]
        public string StateAbbreviationDescriptor { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class EdFiInterventionStudyStateAbbreviation {\n");
            sb.Append("  StateAbbreviationDescriptor: ").Append(StateAbbreviationDescriptor).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as EdFiInterventionStudyStateAbbreviation);
        }

        /// <summary>
        /// Returns true if EdFiInterventionStudyStateAbbreviation instances are equal
        /// </summary>
        /// <param name="input">Instance of EdFiInterventionStudyStateAbbreviation to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(EdFiInterventionStudyStateAbbreviation input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.StateAbbreviationDescriptor == input.StateAbbreviationDescriptor ||
                    (this.StateAbbreviationDescriptor != null &&
                    this.StateAbbreviationDescriptor.Equals(input.StateAbbreviationDescriptor))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.StateAbbreviationDescriptor != null)
                    hashCode = hashCode * 59 + this.StateAbbreviationDescriptor.GetHashCode();
                return hashCode;
            }
        }
    }

}
