/* 
 * Ed-Fi Operational Data Store API
 *
 * The Ed-Fi ODS / API enables applications to read and write education data stored in an Ed-Fi ODS through a secure REST interface.  ***  > *Note: Consumers of ODS / API information should sanitize all data for display and storage. The ODS / API provides reasonable safeguards against cross-site scripting attacks and other malicious content, but the platform does not and cannot guarantee that the data it contains is free of all potentially harmful content.*  *** 
 *
 * OpenAPI spec version: 3
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using SwaggerDateConverter = EdFi.OdsApi.Sdk.Client.SwaggerDateConverter;

namespace EdFi.OdsApi.Sdk.Models.Resources
{
    /// <summary>
    /// EdFiInterventionStudyURI
    /// </summary>
    [DataContract]
    public partial class EdFiInterventionStudyURI :  IEquatable<EdFiInterventionStudyURI>
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="EdFiInterventionStudyURI" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected EdFiInterventionStudyURI() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="EdFiInterventionStudyURI" /> class.
        /// </summary>
        /// <param name="uri">The URI (typical a URL) pointing to an education content item. (required).</param>
        public EdFiInterventionStudyURI(string uri = default(string))
        {
            // to ensure "uri" is required (not null)
            if (uri == null)
            {
                throw new InvalidDataException("uri is a required property for EdFiInterventionStudyURI and cannot be null");
            }
            else
            {
                this.Uri = uri;
            }
        }
        
        /// <summary>
        /// The URI (typical a URL) pointing to an education content item.
        /// </summary>
        /// <value>The URI (typical a URL) pointing to an education content item.</value>
        [DataMember(Name="uri", EmitDefaultValue=false)]
        public string Uri { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class EdFiInterventionStudyURI {\n");
            sb.Append("  Uri: ").Append(Uri).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as EdFiInterventionStudyURI);
        }

        /// <summary>
        /// Returns true if EdFiInterventionStudyURI instances are equal
        /// </summary>
        /// <param name="input">Instance of EdFiInterventionStudyURI to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(EdFiInterventionStudyURI input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.Uri == input.Uri ||
                    (this.Uri != null &&
                    this.Uri.Equals(input.Uri))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Uri != null)
                    hashCode = hashCode * 59 + this.Uri.GetHashCode();
                return hashCode;
            }
        }
    }

}
