/* 
 * Ed-Fi Operational Data Store API
 *
 * The Ed-Fi ODS / API enables applications to read and write education data stored in an Ed-Fi ODS through a secure REST interface.  ***  > *Note: Consumers of ODS / API information should sanitize all data for display and storage. The ODS / API provides reasonable safeguards against cross-site scripting attacks and other malicious content, but the platform does not and cannot guarantee that the data it contains is free of all potentially harmful content.*  *** 
 *
 * OpenAPI spec version: 3
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using SwaggerDateConverter = EdFi.OdsApi.Sdk.Client.SwaggerDateConverter;

namespace EdFi.OdsApi.Sdk.Models.Resources
{
    /// <summary>
    /// EdFiPostSecondaryInstitutionReference
    /// </summary>
    [DataContract]
    public partial class EdFiPostSecondaryInstitutionReference :  IEquatable<EdFiPostSecondaryInstitutionReference>
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="EdFiPostSecondaryInstitutionReference" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected EdFiPostSecondaryInstitutionReference() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="EdFiPostSecondaryInstitutionReference" /> class.
        /// </summary>
        /// <param name="postSecondaryInstitutionId">The ID of the post secondary institution. (required).</param>
        /// <param name="link">link.</param>
        public EdFiPostSecondaryInstitutionReference(int? postSecondaryInstitutionId = default(int?), Link link = default(Link))
        {
            // to ensure "postSecondaryInstitutionId" is required (not null)
            if (postSecondaryInstitutionId == null)
            {
                throw new InvalidDataException("postSecondaryInstitutionId is a required property for EdFiPostSecondaryInstitutionReference and cannot be null");
            }
            else
            {
                this.PostSecondaryInstitutionId = postSecondaryInstitutionId;
            }
            this.Link = link;
        }
        
        /// <summary>
        /// The ID of the post secondary institution.
        /// </summary>
        /// <value>The ID of the post secondary institution.</value>
        [DataMember(Name="postSecondaryInstitutionId", EmitDefaultValue=false)]
        public int? PostSecondaryInstitutionId { get; set; }

        /// <summary>
        /// Gets or Sets Link
        /// </summary>
        [DataMember(Name="link", EmitDefaultValue=false)]
        public Link Link { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class EdFiPostSecondaryInstitutionReference {\n");
            sb.Append("  PostSecondaryInstitutionId: ").Append(PostSecondaryInstitutionId).Append("\n");
            sb.Append("  Link: ").Append(Link).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as EdFiPostSecondaryInstitutionReference);
        }

        /// <summary>
        /// Returns true if EdFiPostSecondaryInstitutionReference instances are equal
        /// </summary>
        /// <param name="input">Instance of EdFiPostSecondaryInstitutionReference to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(EdFiPostSecondaryInstitutionReference input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.PostSecondaryInstitutionId == input.PostSecondaryInstitutionId ||
                    (this.PostSecondaryInstitutionId != null &&
                    this.PostSecondaryInstitutionId.Equals(input.PostSecondaryInstitutionId))
                ) && 
                (
                    this.Link == input.Link ||
                    (this.Link != null &&
                    this.Link.Equals(input.Link))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.PostSecondaryInstitutionId != null)
                    hashCode = hashCode * 59 + this.PostSecondaryInstitutionId.GetHashCode();
                if (this.Link != null)
                    hashCode = hashCode * 59 + this.Link.GetHashCode();
                return hashCode;
            }
        }
    }

}
