/* 
 * Ed-Fi Operational Data Store API
 *
 * The Ed-Fi ODS / API enables applications to read and write education data stored in an Ed-Fi ODS through a secure REST interface.  ***  > *Note: Consumers of ODS / API information should sanitize all data for display and storage. The ODS / API provides reasonable safeguards against cross-site scripting attacks and other malicious content, but the platform does not and cannot guarantee that the data it contains is free of all potentially harmful content.*  *** 
 *
 * OpenAPI spec version: 3
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using SwaggerDateConverter = EdFi.OdsApi.Sdk.Client.SwaggerDateConverter;

namespace EdFi.OdsApi.Sdk.Models.Resources
{
    /// <summary>
    /// EdFiReportCardStudentCompetencyObjective
    /// </summary>
    [DataContract]
    public partial class EdFiReportCardStudentCompetencyObjective :  IEquatable<EdFiReportCardStudentCompetencyObjective>
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="EdFiReportCardStudentCompetencyObjective" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected EdFiReportCardStudentCompetencyObjective() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="EdFiReportCardStudentCompetencyObjective" /> class.
        /// </summary>
        /// <param name="studentCompetencyObjectiveReference">studentCompetencyObjectiveReference (required).</param>
        public EdFiReportCardStudentCompetencyObjective(EdFiStudentCompetencyObjectiveReference studentCompetencyObjectiveReference = default(EdFiStudentCompetencyObjectiveReference))
        {
            // to ensure "studentCompetencyObjectiveReference" is required (not null)
            if (studentCompetencyObjectiveReference == null)
            {
                throw new InvalidDataException("studentCompetencyObjectiveReference is a required property for EdFiReportCardStudentCompetencyObjective and cannot be null");
            }
            else
            {
                this.StudentCompetencyObjectiveReference = studentCompetencyObjectiveReference;
            }
        }
        
        /// <summary>
        /// Gets or Sets StudentCompetencyObjectiveReference
        /// </summary>
        [DataMember(Name="studentCompetencyObjectiveReference", EmitDefaultValue=false)]
        public EdFiStudentCompetencyObjectiveReference StudentCompetencyObjectiveReference { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class EdFiReportCardStudentCompetencyObjective {\n");
            sb.Append("  StudentCompetencyObjectiveReference: ").Append(StudentCompetencyObjectiveReference).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as EdFiReportCardStudentCompetencyObjective);
        }

        /// <summary>
        /// Returns true if EdFiReportCardStudentCompetencyObjective instances are equal
        /// </summary>
        /// <param name="input">Instance of EdFiReportCardStudentCompetencyObjective to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(EdFiReportCardStudentCompetencyObjective input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.StudentCompetencyObjectiveReference == input.StudentCompetencyObjectiveReference ||
                    (this.StudentCompetencyObjectiveReference != null &&
                    this.StudentCompetencyObjectiveReference.Equals(input.StudentCompetencyObjectiveReference))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.StudentCompetencyObjectiveReference != null)
                    hashCode = hashCode * 59 + this.StudentCompetencyObjectiveReference.GetHashCode();
                return hashCode;
            }
        }
    }

}
