/* 
 * Ed-Fi Operational Data Store API
 *
 * The Ed-Fi ODS / API enables applications to read and write education data stored in an Ed-Fi ODS through a secure REST interface.  ***  > *Note: Consumers of ODS / API information should sanitize all data for display and storage. The ODS / API provides reasonable safeguards against cross-site scripting attacks and other malicious content, but the platform does not and cannot guarantee that the data it contains is free of all potentially harmful content.*  *** 
 *
 * OpenAPI spec version: 3
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using SwaggerDateConverter = EdFi.OdsApi.Sdk.Client.SwaggerDateConverter;

namespace EdFi.OdsApi.Sdk.Models.Resources
{
    /// <summary>
    /// EdFiStudentDisciplineIncidentAssociationBehavior
    /// </summary>
    [DataContract]
    public partial class EdFiStudentDisciplineIncidentAssociationBehavior :  IEquatable<EdFiStudentDisciplineIncidentAssociationBehavior>
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="EdFiStudentDisciplineIncidentAssociationBehavior" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected EdFiStudentDisciplineIncidentAssociationBehavior() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="EdFiStudentDisciplineIncidentAssociationBehavior" /> class.
        /// </summary>
        /// <param name="behaviorDescriptor">Describes behavior by category and provides a detailed description. (required).</param>
        /// <param name="behaviorDetailedDescription">Specifies a more granular level of detail of a behavior involved in the incident..</param>
        public EdFiStudentDisciplineIncidentAssociationBehavior(string behaviorDescriptor = default(string), string behaviorDetailedDescription = default(string))
        {
            // to ensure "behaviorDescriptor" is required (not null)
            if (behaviorDescriptor == null)
            {
                throw new InvalidDataException("behaviorDescriptor is a required property for EdFiStudentDisciplineIncidentAssociationBehavior and cannot be null");
            }
            else
            {
                this.BehaviorDescriptor = behaviorDescriptor;
            }
            this.BehaviorDetailedDescription = behaviorDetailedDescription;
        }
        
        /// <summary>
        /// Describes behavior by category and provides a detailed description.
        /// </summary>
        /// <value>Describes behavior by category and provides a detailed description.</value>
        [DataMember(Name="behaviorDescriptor", EmitDefaultValue=false)]
        public string BehaviorDescriptor { get; set; }

        /// <summary>
        /// Specifies a more granular level of detail of a behavior involved in the incident.
        /// </summary>
        /// <value>Specifies a more granular level of detail of a behavior involved in the incident.</value>
        [DataMember(Name="behaviorDetailedDescription", EmitDefaultValue=false)]
        public string BehaviorDetailedDescription { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class EdFiStudentDisciplineIncidentAssociationBehavior {\n");
            sb.Append("  BehaviorDescriptor: ").Append(BehaviorDescriptor).Append("\n");
            sb.Append("  BehaviorDetailedDescription: ").Append(BehaviorDetailedDescription).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as EdFiStudentDisciplineIncidentAssociationBehavior);
        }

        /// <summary>
        /// Returns true if EdFiStudentDisciplineIncidentAssociationBehavior instances are equal
        /// </summary>
        /// <param name="input">Instance of EdFiStudentDisciplineIncidentAssociationBehavior to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(EdFiStudentDisciplineIncidentAssociationBehavior input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.BehaviorDescriptor == input.BehaviorDescriptor ||
                    (this.BehaviorDescriptor != null &&
                    this.BehaviorDescriptor.Equals(input.BehaviorDescriptor))
                ) && 
                (
                    this.BehaviorDetailedDescription == input.BehaviorDetailedDescription ||
                    (this.BehaviorDetailedDescription != null &&
                    this.BehaviorDetailedDescription.Equals(input.BehaviorDetailedDescription))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.BehaviorDescriptor != null)
                    hashCode = hashCode * 59 + this.BehaviorDescriptor.GetHashCode();
                if (this.BehaviorDetailedDescription != null)
                    hashCode = hashCode * 59 + this.BehaviorDetailedDescription.GetHashCode();
                return hashCode;
            }
        }
    }

}
