/* 
 * Ed-Fi Operational Data Store API
 *
 * The Ed-Fi ODS / API enables applications to read and write education data stored in an Ed-Fi ODS through a secure REST interface.  ***  > *Note: Consumers of ODS / API information should sanitize all data for display and storage. The ODS / API provides reasonable safeguards against cross-site scripting attacks and other malicious content, but the platform does not and cannot guarantee that the data it contains is free of all potentially harmful content.*  *** 
 *
 * OpenAPI spec version: 3
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using SwaggerDateConverter = EdFi.OdsApi.Sdk.Client.SwaggerDateConverter;

namespace EdFi.OdsApi.Sdk.Models.Resources
{
    /// <summary>
    /// EdFiXFinanceFunctionDimensionReference
    /// </summary>
    [DataContract]
    public partial class EdFiXFinanceFunctionDimensionReference :  IEquatable<EdFiXFinanceFunctionDimensionReference>
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="EdFiXFinanceFunctionDimensionReference" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected EdFiXFinanceFunctionDimensionReference() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="EdFiXFinanceFunctionDimensionReference" /> class.
        /// </summary>
        /// <param name="code">The code representation of the account Function dimension. (required).</param>
        /// <param name="fiscalYear">The fiscal year for which the account Function dimension is valid. (required).</param>
        /// <param name="link">link.</param>
        public EdFiXFinanceFunctionDimensionReference(string code = default(string), int? fiscalYear = default(int?), Link link = default(Link))
        {
            // to ensure "code" is required (not null)
            if (code == null)
            {
                throw new InvalidDataException("code is a required property for EdFiXFinanceFunctionDimensionReference and cannot be null");
            }
            else
            {
                this.Code = code;
            }
            // to ensure "fiscalYear" is required (not null)
            if (fiscalYear == null)
            {
                throw new InvalidDataException("fiscalYear is a required property for EdFiXFinanceFunctionDimensionReference and cannot be null");
            }
            else
            {
                this.FiscalYear = fiscalYear;
            }
            this.Link = link;
        }
        
        /// <summary>
        /// The code representation of the account Function dimension.
        /// </summary>
        /// <value>The code representation of the account Function dimension.</value>
        [DataMember(Name="code", EmitDefaultValue=false)]
        public string Code { get; set; }

        /// <summary>
        /// The fiscal year for which the account Function dimension is valid.
        /// </summary>
        /// <value>The fiscal year for which the account Function dimension is valid.</value>
        [DataMember(Name="fiscalYear", EmitDefaultValue=false)]
        public int? FiscalYear { get; set; }

        /// <summary>
        /// Gets or Sets Link
        /// </summary>
        [DataMember(Name="link", EmitDefaultValue=false)]
        public Link Link { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class EdFiXFinanceFunctionDimensionReference {\n");
            sb.Append("  Code: ").Append(Code).Append("\n");
            sb.Append("  FiscalYear: ").Append(FiscalYear).Append("\n");
            sb.Append("  Link: ").Append(Link).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as EdFiXFinanceFunctionDimensionReference);
        }

        /// <summary>
        /// Returns true if EdFiXFinanceFunctionDimensionReference instances are equal
        /// </summary>
        /// <param name="input">Instance of EdFiXFinanceFunctionDimensionReference to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(EdFiXFinanceFunctionDimensionReference input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.Code == input.Code ||
                    (this.Code != null &&
                    this.Code.Equals(input.Code))
                ) && 
                (
                    this.FiscalYear == input.FiscalYear ||
                    (this.FiscalYear != null &&
                    this.FiscalYear.Equals(input.FiscalYear))
                ) && 
                (
                    this.Link == input.Link ||
                    (this.Link != null &&
                    this.Link.Equals(input.Link))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Code != null)
                    hashCode = hashCode * 59 + this.Code.GetHashCode();
                if (this.FiscalYear != null)
                    hashCode = hashCode * 59 + this.FiscalYear.GetHashCode();
                if (this.Link != null)
                    hashCode = hashCode * 59 + this.Link.GetHashCode();
                return hashCode;
            }
        }
    }

}
