/* 
 * Ed-Fi Operational Data Store API
 *
 * The Ed-Fi ODS / API enables applications to read and write education data stored in an Ed-Fi ODS through a secure REST interface.  ***  > *Note: Consumers of ODS / API information should sanitize all data for display and storage. The ODS / API provides reasonable safeguards against cross-site scripting attacks and other malicious content, but the platform does not and cannot guarantee that the data it contains is free of all potentially harmful content.*  *** 
 *
 * OpenAPI spec version: 3
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using SwaggerDateConverter = EdFi.OdsApi.Sdk.Client.SwaggerDateConverter;

namespace EdFi.OdsApi.Sdk.Models.Resources
{
    /// <summary>
    /// EdFiXFinanceLocalAccountReportingTag
    /// </summary>
    [DataContract]
    public partial class EdFiXFinanceLocalAccountReportingTag :  IEquatable<EdFiXFinanceLocalAccountReportingTag>
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="EdFiXFinanceLocalAccountReportingTag" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected EdFiXFinanceLocalAccountReportingTag() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="EdFiXFinanceLocalAccountReportingTag" /> class.
        /// </summary>
        /// <param name="reportingTagDescriptor">ReportinTag Descriptor (required).</param>
        /// <param name="tagValue">TagValue.</param>
        public EdFiXFinanceLocalAccountReportingTag(string reportingTagDescriptor = default(string), string tagValue = default(string))
        {
            // to ensure "reportingTagDescriptor" is required (not null)
            if (reportingTagDescriptor == null)
            {
                throw new InvalidDataException("reportingTagDescriptor is a required property for EdFiXFinanceLocalAccountReportingTag and cannot be null");
            }
            else
            {
                this.ReportingTagDescriptor = reportingTagDescriptor;
            }
            this.TagValue = tagValue;
        }
        
        /// <summary>
        /// ReportinTag Descriptor
        /// </summary>
        /// <value>ReportinTag Descriptor</value>
        [DataMember(Name="reportingTagDescriptor", EmitDefaultValue=false)]
        public string ReportingTagDescriptor { get; set; }

        /// <summary>
        /// TagValue
        /// </summary>
        /// <value>TagValue</value>
        [DataMember(Name="tagValue", EmitDefaultValue=false)]
        public string TagValue { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class EdFiXFinanceLocalAccountReportingTag {\n");
            sb.Append("  ReportingTagDescriptor: ").Append(ReportingTagDescriptor).Append("\n");
            sb.Append("  TagValue: ").Append(TagValue).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as EdFiXFinanceLocalAccountReportingTag);
        }

        /// <summary>
        /// Returns true if EdFiXFinanceLocalAccountReportingTag instances are equal
        /// </summary>
        /// <param name="input">Instance of EdFiXFinanceLocalAccountReportingTag to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(EdFiXFinanceLocalAccountReportingTag input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.ReportingTagDescriptor == input.ReportingTagDescriptor ||
                    (this.ReportingTagDescriptor != null &&
                    this.ReportingTagDescriptor.Equals(input.ReportingTagDescriptor))
                ) && 
                (
                    this.TagValue == input.TagValue ||
                    (this.TagValue != null &&
                    this.TagValue.Equals(input.TagValue))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.ReportingTagDescriptor != null)
                    hashCode = hashCode * 59 + this.ReportingTagDescriptor.GetHashCode();
                if (this.TagValue != null)
                    hashCode = hashCode * 59 + this.TagValue.GetHashCode();
                return hashCode;
            }
        }
    }

}
