/* 
 * Ed-Fi Operational Data Store API
 *
 * The Ed-Fi ODS / API enables applications to read and write education data stored in an Ed-Fi ODS through a secure REST interface.  ***  > *Note: Consumers of ODS / API information should sanitize all data for display and storage. The ODS / API provides reasonable safeguards against cross-site scripting attacks and other malicious content, but the platform does not and cannot guarantee that the data it contains is free of all potentially harmful content.*  *** 
 *
 * OpenAPI spec version: 3
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using SwaggerDateConverter = EdFi.OdsApi.Sdk.Client.SwaggerDateConverter;

namespace EdFi.OdsApi.Sdk.Models.Resources
{
    /// <summary>
    /// EdFiXSpecialEducationEligibilityStudentSpecialEducationProgramEligibilityAssociation
    /// </summary>
    [DataContract]
    public partial class EdFiXSpecialEducationEligibilityStudentSpecialEducationProgramEligibilityAssociation :  IEquatable<EdFiXSpecialEducationEligibilityStudentSpecialEducationProgramEligibilityAssociation>
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="EdFiXSpecialEducationEligibilityStudentSpecialEducationProgramEligibilityAssociation" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected EdFiXSpecialEducationEligibilityStudentSpecialEducationProgramEligibilityAssociation() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="EdFiXSpecialEducationEligibilityStudentSpecialEducationProgramEligibilityAssociation" /> class.
        /// </summary>
        /// <param name="id">id.</param>
        /// <param name="consentToEvaluationReceivedDate">Indicates the date on which the Local Education Agency received written consent for the evaluation from the student&#39;s parent. (required).</param>
        /// <param name="educationOrganizationReference">educationOrganizationReference (required).</param>
        /// <param name="programReference">programReference (required).</param>
        /// <param name="studentReference">studentReference (required).</param>
        /// <param name="consentToEvaluationDate">The date in which the student&#39;s parent gave a consent (Parent Consent Date).</param>
        /// <param name="eligibilityDeterminationDate">Indicates the month, day, and year the LEA held the admission, review, and dismissal committee meeting regarding the child&#39;s eligibility determination for special education and related services. An individualized education plan (IEP) would be developed and implemented for a child admitted into special education on this same date.</param>
        /// <param name="eligibilityEvaluationDate">Indicates the month, day, and year when the written individual evaluation report was completed..</param>
        /// <param name="eligibilityEvaluationTypeDescriptor">Indicates if this is an initial or reevaluation. (required).</param>
        /// <param name="evaluationCompleteIndicator">Indicates the evaluation completed status..</param>
        /// <param name="evaluationDelayDays">Indicates the number of student absences, if any, beginning the first instructional day following the date on which the Local Education Agency (LEA) received written parental consent for the evaluation..</param>
        /// <param name="evaluationDelayReasonDescriptor">Refers to the justification as to why the evaluation report was completed beyond the State-established timeframe..</param>
        /// <param name="evaluationLateReason">Refers to additional information for delay in doing the evaluation..</param>
        /// <param name="ideaIndicator">Indicates whether or not the student was determined eligible and enrolled in special education and related services as a result of the evaluation report and the admission, review, and dismissal committee meeting decision..</param>
        /// <param name="ideaPartDescriptor">Indicates if the evaluation is done under Part B IDEA or Part C IDEA (required).</param>
        /// <param name="transitionConferenceDate">Indicates the month, day, and year when the transition conference was held (for a child receiving early childhood intervention (ECI) services) among the lead agency, the family, and the LEA where the child resides to discuss the child s potential eligibility for early childhood special education (ECSE) services..</param>
        /// <param name="transitionNotificationDate">Indicates the month, day, and year the LEA Notification of Potentially Eligible for Special Education Services was sent by the early childhood intervention (ECI) contractor to the local education agency (LEA) to notify them that a child enrolled in ECI will shortly reach the age of eligibility for Part B services and the child is potentially eligible for services under Part B, early childhood special education (ECSE). The LEA Notification constitutes a referral to the LEA for an initial evaluation and eligibility determination of the child which the parent may opt out from the referral..</param>
        /// <param name="etag">A unique system-generated value that identifies the version of the resource..</param>
        public EdFiXSpecialEducationEligibilityStudentSpecialEducationProgramEligibilityAssociation(string id = default(string), DateTime? consentToEvaluationReceivedDate = default(DateTime?), EdFiEducationOrganizationReference educationOrganizationReference = default(EdFiEducationOrganizationReference), EdFiProgramReference programReference = default(EdFiProgramReference), EdFiStudentReference studentReference = default(EdFiStudentReference), DateTime? consentToEvaluationDate = default(DateTime?), DateTime? eligibilityDeterminationDate = default(DateTime?), DateTime? eligibilityEvaluationDate = default(DateTime?), string eligibilityEvaluationTypeDescriptor = default(string), bool? evaluationCompleteIndicator = default(bool?), int? evaluationDelayDays = default(int?), string evaluationDelayReasonDescriptor = default(string), string evaluationLateReason = default(string), bool? ideaIndicator = default(bool?), string ideaPartDescriptor = default(string), DateTime? transitionConferenceDate = default(DateTime?), DateTime? transitionNotificationDate = default(DateTime?), string etag = default(string))
        {
            // to ensure "consentToEvaluationReceivedDate" is required (not null)
            if (consentToEvaluationReceivedDate == null)
            {
                throw new InvalidDataException("consentToEvaluationReceivedDate is a required property for EdFiXSpecialEducationEligibilityStudentSpecialEducationProgramEligibilityAssociation and cannot be null");
            }
            else
            {
                this.ConsentToEvaluationReceivedDate = consentToEvaluationReceivedDate;
            }
            // to ensure "educationOrganizationReference" is required (not null)
            if (educationOrganizationReference == null)
            {
                throw new InvalidDataException("educationOrganizationReference is a required property for EdFiXSpecialEducationEligibilityStudentSpecialEducationProgramEligibilityAssociation and cannot be null");
            }
            else
            {
                this.EducationOrganizationReference = educationOrganizationReference;
            }
            // to ensure "programReference" is required (not null)
            if (programReference == null)
            {
                throw new InvalidDataException("programReference is a required property for EdFiXSpecialEducationEligibilityStudentSpecialEducationProgramEligibilityAssociation and cannot be null");
            }
            else
            {
                this.ProgramReference = programReference;
            }
            // to ensure "studentReference" is required (not null)
            if (studentReference == null)
            {
                throw new InvalidDataException("studentReference is a required property for EdFiXSpecialEducationEligibilityStudentSpecialEducationProgramEligibilityAssociation and cannot be null");
            }
            else
            {
                this.StudentReference = studentReference;
            }
            // to ensure "eligibilityEvaluationTypeDescriptor" is required (not null)
            if (eligibilityEvaluationTypeDescriptor == null)
            {
                throw new InvalidDataException("eligibilityEvaluationTypeDescriptor is a required property for EdFiXSpecialEducationEligibilityStudentSpecialEducationProgramEligibilityAssociation and cannot be null");
            }
            else
            {
                this.EligibilityEvaluationTypeDescriptor = eligibilityEvaluationTypeDescriptor;
            }
            // to ensure "ideaPartDescriptor" is required (not null)
            if (ideaPartDescriptor == null)
            {
                throw new InvalidDataException("ideaPartDescriptor is a required property for EdFiXSpecialEducationEligibilityStudentSpecialEducationProgramEligibilityAssociation and cannot be null");
            }
            else
            {
                this.IdeaPartDescriptor = ideaPartDescriptor;
            }
            this.Id = id;
            this.ConsentToEvaluationDate = consentToEvaluationDate;
            this.EligibilityDeterminationDate = eligibilityDeterminationDate;
            this.EligibilityEvaluationDate = eligibilityEvaluationDate;
            this.EvaluationCompleteIndicator = evaluationCompleteIndicator;
            this.EvaluationDelayDays = evaluationDelayDays;
            this.EvaluationDelayReasonDescriptor = evaluationDelayReasonDescriptor;
            this.EvaluationLateReason = evaluationLateReason;
            this.IdeaIndicator = ideaIndicator;
            this.TransitionConferenceDate = transitionConferenceDate;
            this.TransitionNotificationDate = transitionNotificationDate;
            this.Etag = etag;
        }
        
        /// <summary>
        /// Gets or Sets Id
        /// </summary>
        [DataMember(Name="id", EmitDefaultValue=false)]
        public string Id { get; set; }

        /// <summary>
        /// Indicates the date on which the Local Education Agency received written consent for the evaluation from the student&#39;s parent.
        /// </summary>
        /// <value>Indicates the date on which the Local Education Agency received written consent for the evaluation from the student&#39;s parent.</value>
        [DataMember(Name="consentToEvaluationReceivedDate", EmitDefaultValue=false)]
        [JsonConverter(typeof(SwaggerDateConverter))]
        public DateTime? ConsentToEvaluationReceivedDate { get; set; }

        /// <summary>
        /// Gets or Sets EducationOrganizationReference
        /// </summary>
        [DataMember(Name="educationOrganizationReference", EmitDefaultValue=false)]
        public EdFiEducationOrganizationReference EducationOrganizationReference { get; set; }

        /// <summary>
        /// Gets or Sets ProgramReference
        /// </summary>
        [DataMember(Name="programReference", EmitDefaultValue=false)]
        public EdFiProgramReference ProgramReference { get; set; }

        /// <summary>
        /// Gets or Sets StudentReference
        /// </summary>
        [DataMember(Name="studentReference", EmitDefaultValue=false)]
        public EdFiStudentReference StudentReference { get; set; }

        /// <summary>
        /// The date in which the student&#39;s parent gave a consent (Parent Consent Date)
        /// </summary>
        /// <value>The date in which the student&#39;s parent gave a consent (Parent Consent Date)</value>
        [DataMember(Name="consentToEvaluationDate", EmitDefaultValue=false)]
        [JsonConverter(typeof(SwaggerDateConverter))]
        public DateTime? ConsentToEvaluationDate { get; set; }

        /// <summary>
        /// Indicates the month, day, and year the LEA held the admission, review, and dismissal committee meeting regarding the child&#39;s eligibility determination for special education and related services. An individualized education plan (IEP) would be developed and implemented for a child admitted into special education on this same date
        /// </summary>
        /// <value>Indicates the month, day, and year the LEA held the admission, review, and dismissal committee meeting regarding the child&#39;s eligibility determination for special education and related services. An individualized education plan (IEP) would be developed and implemented for a child admitted into special education on this same date</value>
        [DataMember(Name="eligibilityDeterminationDate", EmitDefaultValue=false)]
        [JsonConverter(typeof(SwaggerDateConverter))]
        public DateTime? EligibilityDeterminationDate { get; set; }

        /// <summary>
        /// Indicates the month, day, and year when the written individual evaluation report was completed.
        /// </summary>
        /// <value>Indicates the month, day, and year when the written individual evaluation report was completed.</value>
        [DataMember(Name="eligibilityEvaluationDate", EmitDefaultValue=false)]
        [JsonConverter(typeof(SwaggerDateConverter))]
        public DateTime? EligibilityEvaluationDate { get; set; }

        /// <summary>
        /// Indicates if this is an initial or reevaluation.
        /// </summary>
        /// <value>Indicates if this is an initial or reevaluation.</value>
        [DataMember(Name="eligibilityEvaluationTypeDescriptor", EmitDefaultValue=false)]
        public string EligibilityEvaluationTypeDescriptor { get; set; }

        /// <summary>
        /// Indicates the evaluation completed status.
        /// </summary>
        /// <value>Indicates the evaluation completed status.</value>
        [DataMember(Name="evaluationCompleteIndicator", EmitDefaultValue=false)]
        public bool? EvaluationCompleteIndicator { get; set; }

        /// <summary>
        /// Indicates the number of student absences, if any, beginning the first instructional day following the date on which the Local Education Agency (LEA) received written parental consent for the evaluation.
        /// </summary>
        /// <value>Indicates the number of student absences, if any, beginning the first instructional day following the date on which the Local Education Agency (LEA) received written parental consent for the evaluation.</value>
        [DataMember(Name="evaluationDelayDays", EmitDefaultValue=false)]
        public int? EvaluationDelayDays { get; set; }

        /// <summary>
        /// Refers to the justification as to why the evaluation report was completed beyond the State-established timeframe.
        /// </summary>
        /// <value>Refers to the justification as to why the evaluation report was completed beyond the State-established timeframe.</value>
        [DataMember(Name="evaluationDelayReasonDescriptor", EmitDefaultValue=false)]
        public string EvaluationDelayReasonDescriptor { get; set; }

        /// <summary>
        /// Refers to additional information for delay in doing the evaluation.
        /// </summary>
        /// <value>Refers to additional information for delay in doing the evaluation.</value>
        [DataMember(Name="evaluationLateReason", EmitDefaultValue=false)]
        public string EvaluationLateReason { get; set; }

        /// <summary>
        /// Indicates whether or not the student was determined eligible and enrolled in special education and related services as a result of the evaluation report and the admission, review, and dismissal committee meeting decision.
        /// </summary>
        /// <value>Indicates whether or not the student was determined eligible and enrolled in special education and related services as a result of the evaluation report and the admission, review, and dismissal committee meeting decision.</value>
        [DataMember(Name="ideaIndicator", EmitDefaultValue=false)]
        public bool? IdeaIndicator { get; set; }

        /// <summary>
        /// Indicates if the evaluation is done under Part B IDEA or Part C IDEA
        /// </summary>
        /// <value>Indicates if the evaluation is done under Part B IDEA or Part C IDEA</value>
        [DataMember(Name="ideaPartDescriptor", EmitDefaultValue=false)]
        public string IdeaPartDescriptor { get; set; }

        /// <summary>
        /// Indicates the month, day, and year when the transition conference was held (for a child receiving early childhood intervention (ECI) services) among the lead agency, the family, and the LEA where the child resides to discuss the child s potential eligibility for early childhood special education (ECSE) services.
        /// </summary>
        /// <value>Indicates the month, day, and year when the transition conference was held (for a child receiving early childhood intervention (ECI) services) among the lead agency, the family, and the LEA where the child resides to discuss the child s potential eligibility for early childhood special education (ECSE) services.</value>
        [DataMember(Name="transitionConferenceDate", EmitDefaultValue=false)]
        [JsonConverter(typeof(SwaggerDateConverter))]
        public DateTime? TransitionConferenceDate { get; set; }

        /// <summary>
        /// Indicates the month, day, and year the LEA Notification of Potentially Eligible for Special Education Services was sent by the early childhood intervention (ECI) contractor to the local education agency (LEA) to notify them that a child enrolled in ECI will shortly reach the age of eligibility for Part B services and the child is potentially eligible for services under Part B, early childhood special education (ECSE). The LEA Notification constitutes a referral to the LEA for an initial evaluation and eligibility determination of the child which the parent may opt out from the referral.
        /// </summary>
        /// <value>Indicates the month, day, and year the LEA Notification of Potentially Eligible for Special Education Services was sent by the early childhood intervention (ECI) contractor to the local education agency (LEA) to notify them that a child enrolled in ECI will shortly reach the age of eligibility for Part B services and the child is potentially eligible for services under Part B, early childhood special education (ECSE). The LEA Notification constitutes a referral to the LEA for an initial evaluation and eligibility determination of the child which the parent may opt out from the referral.</value>
        [DataMember(Name="transitionNotificationDate", EmitDefaultValue=false)]
        [JsonConverter(typeof(SwaggerDateConverter))]
        public DateTime? TransitionNotificationDate { get; set; }

        /// <summary>
        /// A unique system-generated value that identifies the version of the resource.
        /// </summary>
        /// <value>A unique system-generated value that identifies the version of the resource.</value>
        [DataMember(Name="_etag", EmitDefaultValue=false)]
        public string Etag { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class EdFiXSpecialEducationEligibilityStudentSpecialEducationProgramEligibilityAssociation {\n");
            sb.Append("  Id: ").Append(Id).Append("\n");
            sb.Append("  ConsentToEvaluationReceivedDate: ").Append(ConsentToEvaluationReceivedDate).Append("\n");
            sb.Append("  EducationOrganizationReference: ").Append(EducationOrganizationReference).Append("\n");
            sb.Append("  ProgramReference: ").Append(ProgramReference).Append("\n");
            sb.Append("  StudentReference: ").Append(StudentReference).Append("\n");
            sb.Append("  ConsentToEvaluationDate: ").Append(ConsentToEvaluationDate).Append("\n");
            sb.Append("  EligibilityDeterminationDate: ").Append(EligibilityDeterminationDate).Append("\n");
            sb.Append("  EligibilityEvaluationDate: ").Append(EligibilityEvaluationDate).Append("\n");
            sb.Append("  EligibilityEvaluationTypeDescriptor: ").Append(EligibilityEvaluationTypeDescriptor).Append("\n");
            sb.Append("  EvaluationCompleteIndicator: ").Append(EvaluationCompleteIndicator).Append("\n");
            sb.Append("  EvaluationDelayDays: ").Append(EvaluationDelayDays).Append("\n");
            sb.Append("  EvaluationDelayReasonDescriptor: ").Append(EvaluationDelayReasonDescriptor).Append("\n");
            sb.Append("  EvaluationLateReason: ").Append(EvaluationLateReason).Append("\n");
            sb.Append("  IdeaIndicator: ").Append(IdeaIndicator).Append("\n");
            sb.Append("  IdeaPartDescriptor: ").Append(IdeaPartDescriptor).Append("\n");
            sb.Append("  TransitionConferenceDate: ").Append(TransitionConferenceDate).Append("\n");
            sb.Append("  TransitionNotificationDate: ").Append(TransitionNotificationDate).Append("\n");
            sb.Append("  Etag: ").Append(Etag).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as EdFiXSpecialEducationEligibilityStudentSpecialEducationProgramEligibilityAssociation);
        }

        /// <summary>
        /// Returns true if EdFiXSpecialEducationEligibilityStudentSpecialEducationProgramEligibilityAssociation instances are equal
        /// </summary>
        /// <param name="input">Instance of EdFiXSpecialEducationEligibilityStudentSpecialEducationProgramEligibilityAssociation to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(EdFiXSpecialEducationEligibilityStudentSpecialEducationProgramEligibilityAssociation input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.Id == input.Id ||
                    (this.Id != null &&
                    this.Id.Equals(input.Id))
                ) && 
                (
                    this.ConsentToEvaluationReceivedDate == input.ConsentToEvaluationReceivedDate ||
                    (this.ConsentToEvaluationReceivedDate != null &&
                    this.ConsentToEvaluationReceivedDate.Equals(input.ConsentToEvaluationReceivedDate))
                ) && 
                (
                    this.EducationOrganizationReference == input.EducationOrganizationReference ||
                    (this.EducationOrganizationReference != null &&
                    this.EducationOrganizationReference.Equals(input.EducationOrganizationReference))
                ) && 
                (
                    this.ProgramReference == input.ProgramReference ||
                    (this.ProgramReference != null &&
                    this.ProgramReference.Equals(input.ProgramReference))
                ) && 
                (
                    this.StudentReference == input.StudentReference ||
                    (this.StudentReference != null &&
                    this.StudentReference.Equals(input.StudentReference))
                ) && 
                (
                    this.ConsentToEvaluationDate == input.ConsentToEvaluationDate ||
                    (this.ConsentToEvaluationDate != null &&
                    this.ConsentToEvaluationDate.Equals(input.ConsentToEvaluationDate))
                ) && 
                (
                    this.EligibilityDeterminationDate == input.EligibilityDeterminationDate ||
                    (this.EligibilityDeterminationDate != null &&
                    this.EligibilityDeterminationDate.Equals(input.EligibilityDeterminationDate))
                ) && 
                (
                    this.EligibilityEvaluationDate == input.EligibilityEvaluationDate ||
                    (this.EligibilityEvaluationDate != null &&
                    this.EligibilityEvaluationDate.Equals(input.EligibilityEvaluationDate))
                ) && 
                (
                    this.EligibilityEvaluationTypeDescriptor == input.EligibilityEvaluationTypeDescriptor ||
                    (this.EligibilityEvaluationTypeDescriptor != null &&
                    this.EligibilityEvaluationTypeDescriptor.Equals(input.EligibilityEvaluationTypeDescriptor))
                ) && 
                (
                    this.EvaluationCompleteIndicator == input.EvaluationCompleteIndicator ||
                    (this.EvaluationCompleteIndicator != null &&
                    this.EvaluationCompleteIndicator.Equals(input.EvaluationCompleteIndicator))
                ) && 
                (
                    this.EvaluationDelayDays == input.EvaluationDelayDays ||
                    (this.EvaluationDelayDays != null &&
                    this.EvaluationDelayDays.Equals(input.EvaluationDelayDays))
                ) && 
                (
                    this.EvaluationDelayReasonDescriptor == input.EvaluationDelayReasonDescriptor ||
                    (this.EvaluationDelayReasonDescriptor != null &&
                    this.EvaluationDelayReasonDescriptor.Equals(input.EvaluationDelayReasonDescriptor))
                ) && 
                (
                    this.EvaluationLateReason == input.EvaluationLateReason ||
                    (this.EvaluationLateReason != null &&
                    this.EvaluationLateReason.Equals(input.EvaluationLateReason))
                ) && 
                (
                    this.IdeaIndicator == input.IdeaIndicator ||
                    (this.IdeaIndicator != null &&
                    this.IdeaIndicator.Equals(input.IdeaIndicator))
                ) && 
                (
                    this.IdeaPartDescriptor == input.IdeaPartDescriptor ||
                    (this.IdeaPartDescriptor != null &&
                    this.IdeaPartDescriptor.Equals(input.IdeaPartDescriptor))
                ) && 
                (
                    this.TransitionConferenceDate == input.TransitionConferenceDate ||
                    (this.TransitionConferenceDate != null &&
                    this.TransitionConferenceDate.Equals(input.TransitionConferenceDate))
                ) && 
                (
                    this.TransitionNotificationDate == input.TransitionNotificationDate ||
                    (this.TransitionNotificationDate != null &&
                    this.TransitionNotificationDate.Equals(input.TransitionNotificationDate))
                ) && 
                (
                    this.Etag == input.Etag ||
                    (this.Etag != null &&
                    this.Etag.Equals(input.Etag))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Id != null)
                    hashCode = hashCode * 59 + this.Id.GetHashCode();
                if (this.ConsentToEvaluationReceivedDate != null)
                    hashCode = hashCode * 59 + this.ConsentToEvaluationReceivedDate.GetHashCode();
                if (this.EducationOrganizationReference != null)
                    hashCode = hashCode * 59 + this.EducationOrganizationReference.GetHashCode();
                if (this.ProgramReference != null)
                    hashCode = hashCode * 59 + this.ProgramReference.GetHashCode();
                if (this.StudentReference != null)
                    hashCode = hashCode * 59 + this.StudentReference.GetHashCode();
                if (this.ConsentToEvaluationDate != null)
                    hashCode = hashCode * 59 + this.ConsentToEvaluationDate.GetHashCode();
                if (this.EligibilityDeterminationDate != null)
                    hashCode = hashCode * 59 + this.EligibilityDeterminationDate.GetHashCode();
                if (this.EligibilityEvaluationDate != null)
                    hashCode = hashCode * 59 + this.EligibilityEvaluationDate.GetHashCode();
                if (this.EligibilityEvaluationTypeDescriptor != null)
                    hashCode = hashCode * 59 + this.EligibilityEvaluationTypeDescriptor.GetHashCode();
                if (this.EvaluationCompleteIndicator != null)
                    hashCode = hashCode * 59 + this.EvaluationCompleteIndicator.GetHashCode();
                if (this.EvaluationDelayDays != null)
                    hashCode = hashCode * 59 + this.EvaluationDelayDays.GetHashCode();
                if (this.EvaluationDelayReasonDescriptor != null)
                    hashCode = hashCode * 59 + this.EvaluationDelayReasonDescriptor.GetHashCode();
                if (this.EvaluationLateReason != null)
                    hashCode = hashCode * 59 + this.EvaluationLateReason.GetHashCode();
                if (this.IdeaIndicator != null)
                    hashCode = hashCode * 59 + this.IdeaIndicator.GetHashCode();
                if (this.IdeaPartDescriptor != null)
                    hashCode = hashCode * 59 + this.IdeaPartDescriptor.GetHashCode();
                if (this.TransitionConferenceDate != null)
                    hashCode = hashCode * 59 + this.TransitionConferenceDate.GetHashCode();
                if (this.TransitionNotificationDate != null)
                    hashCode = hashCode * 59 + this.TransitionNotificationDate.GetHashCode();
                if (this.Etag != null)
                    hashCode = hashCode * 59 + this.Etag.GetHashCode();
                return hashCode;
            }
        }
    }

}
