/* 
 * Ed-Fi Operational Data Store API
 *
 * The Ed-Fi ODS / API enables applications to read and write education data stored in an Ed-Fi ODS through a secure REST interface.  ***  > *Note: Consumers of ODS / API information should sanitize all data for display and storage. The ODS / API provides reasonable safeguards against cross-site scripting attacks and other malicious content, but the platform does not and cannot guarantee that the data it contains is free of all potentially harmful content.*  *** 
 *
 * OpenAPI spec version: 3
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using SwaggerDateConverter = EdFi.OdsApi.Sdk.Client.SwaggerDateConverter;

namespace EdFi.OdsApi.Sdk.Models.Resources
{
    /// <summary>
    /// WiStudentSchoolAssociationExtension
    /// </summary>
    [DataContract]
    public partial class WiStudentSchoolAssociationExtension :  IEquatable<WiStudentSchoolAssociationExtension>
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="WiStudentSchoolAssociationExtension" /> class.
        /// </summary>
        /// <param name="actualDaysAttendance">actualDaysAttendance.</param>
        /// <param name="completedSchoolTerm">completedSchoolTerm.</param>
        /// <param name="partTimeInstructionalMinutes">Instructional minutes for up to two classes for part-time students.</param>
        /// <param name="possibleDaysAttendance">possibleDaysAttendance.</param>
        /// <param name="privateSchoolChoiceProgramParticipant">privateSchoolChoiceProgramParticipant.</param>
        /// <param name="expectedTransferLocalEducationAgencyReference">expectedTransferLocalEducationAgencyReference.</param>
        /// <param name="expectedTransferSchoolReference">expectedTransferSchoolReference.</param>
        /// <param name="enrollmentTypes">An unordered collection of studentSchoolAssociationEnrollmentTypes. .</param>
        /// <param name="receivingServices">An unordered collection of studentSchoolAssociationReceivingServices. The status of a student during a specific count date.</param>
        public WiStudentSchoolAssociationExtension(double? actualDaysAttendance = default(double?), bool? completedSchoolTerm = default(bool?), int? partTimeInstructionalMinutes = default(int?), double? possibleDaysAttendance = default(double?), bool? privateSchoolChoiceProgramParticipant = default(bool?), EdFiLocalEducationAgencyReference expectedTransferLocalEducationAgencyReference = default(EdFiLocalEducationAgencyReference), EdFiSchoolReference expectedTransferSchoolReference = default(EdFiSchoolReference), List<WiStudentSchoolAssociationEnrollmentType> enrollmentTypes = default(List<WiStudentSchoolAssociationEnrollmentType>), List<WiStudentSchoolAssociationReceivingService> receivingServices = default(List<WiStudentSchoolAssociationReceivingService>))
        {
            this.ActualDaysAttendance = actualDaysAttendance;
            this.CompletedSchoolTerm = completedSchoolTerm;
            this.PartTimeInstructionalMinutes = partTimeInstructionalMinutes;
            this.PossibleDaysAttendance = possibleDaysAttendance;
            this.PrivateSchoolChoiceProgramParticipant = privateSchoolChoiceProgramParticipant;
            this.ExpectedTransferLocalEducationAgencyReference = expectedTransferLocalEducationAgencyReference;
            this.ExpectedTransferSchoolReference = expectedTransferSchoolReference;
            this.EnrollmentTypes = enrollmentTypes;
            this.ReceivingServices = receivingServices;
        }
        
        /// <summary>
        /// Gets or Sets ActualDaysAttendance
        /// </summary>
        [DataMember(Name="actualDaysAttendance", EmitDefaultValue=false)]
        public double? ActualDaysAttendance { get; set; }

        /// <summary>
        /// Gets or Sets CompletedSchoolTerm
        /// </summary>
        [DataMember(Name="completedSchoolTerm", EmitDefaultValue=false)]
        public bool? CompletedSchoolTerm { get; set; }

        /// <summary>
        /// Instructional minutes for up to two classes for part-time students
        /// </summary>
        /// <value>Instructional minutes for up to two classes for part-time students</value>
        [DataMember(Name="partTimeInstructionalMinutes", EmitDefaultValue=false)]
        public int? PartTimeInstructionalMinutes { get; set; }

        /// <summary>
        /// Gets or Sets PossibleDaysAttendance
        /// </summary>
        [DataMember(Name="possibleDaysAttendance", EmitDefaultValue=false)]
        public double? PossibleDaysAttendance { get; set; }

        /// <summary>
        /// Gets or Sets PrivateSchoolChoiceProgramParticipant
        /// </summary>
        [DataMember(Name="privateSchoolChoiceProgramParticipant", EmitDefaultValue=false)]
        public bool? PrivateSchoolChoiceProgramParticipant { get; set; }

        /// <summary>
        /// Gets or Sets ExpectedTransferLocalEducationAgencyReference
        /// </summary>
        [DataMember(Name="expectedTransferLocalEducationAgencyReference", EmitDefaultValue=false)]
        public EdFiLocalEducationAgencyReference ExpectedTransferLocalEducationAgencyReference { get; set; }

        /// <summary>
        /// Gets or Sets ExpectedTransferSchoolReference
        /// </summary>
        [DataMember(Name="expectedTransferSchoolReference", EmitDefaultValue=false)]
        public EdFiSchoolReference ExpectedTransferSchoolReference { get; set; }

        /// <summary>
        /// An unordered collection of studentSchoolAssociationEnrollmentTypes. 
        /// </summary>
        /// <value>An unordered collection of studentSchoolAssociationEnrollmentTypes. </value>
        [DataMember(Name="enrollmentTypes", EmitDefaultValue=false)]
        public List<WiStudentSchoolAssociationEnrollmentType> EnrollmentTypes { get; set; }

        /// <summary>
        /// An unordered collection of studentSchoolAssociationReceivingServices. The status of a student during a specific count date
        /// </summary>
        /// <value>An unordered collection of studentSchoolAssociationReceivingServices. The status of a student during a specific count date</value>
        [DataMember(Name="receivingServices", EmitDefaultValue=false)]
        public List<WiStudentSchoolAssociationReceivingService> ReceivingServices { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class WiStudentSchoolAssociationExtension {\n");
            sb.Append("  ActualDaysAttendance: ").Append(ActualDaysAttendance).Append("\n");
            sb.Append("  CompletedSchoolTerm: ").Append(CompletedSchoolTerm).Append("\n");
            sb.Append("  PartTimeInstructionalMinutes: ").Append(PartTimeInstructionalMinutes).Append("\n");
            sb.Append("  PossibleDaysAttendance: ").Append(PossibleDaysAttendance).Append("\n");
            sb.Append("  PrivateSchoolChoiceProgramParticipant: ").Append(PrivateSchoolChoiceProgramParticipant).Append("\n");
            sb.Append("  ExpectedTransferLocalEducationAgencyReference: ").Append(ExpectedTransferLocalEducationAgencyReference).Append("\n");
            sb.Append("  ExpectedTransferSchoolReference: ").Append(ExpectedTransferSchoolReference).Append("\n");
            sb.Append("  EnrollmentTypes: ").Append(EnrollmentTypes).Append("\n");
            sb.Append("  ReceivingServices: ").Append(ReceivingServices).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as WiStudentSchoolAssociationExtension);
        }

        /// <summary>
        /// Returns true if WiStudentSchoolAssociationExtension instances are equal
        /// </summary>
        /// <param name="input">Instance of WiStudentSchoolAssociationExtension to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(WiStudentSchoolAssociationExtension input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.ActualDaysAttendance == input.ActualDaysAttendance ||
                    (this.ActualDaysAttendance != null &&
                    this.ActualDaysAttendance.Equals(input.ActualDaysAttendance))
                ) && 
                (
                    this.CompletedSchoolTerm == input.CompletedSchoolTerm ||
                    (this.CompletedSchoolTerm != null &&
                    this.CompletedSchoolTerm.Equals(input.CompletedSchoolTerm))
                ) && 
                (
                    this.PartTimeInstructionalMinutes == input.PartTimeInstructionalMinutes ||
                    (this.PartTimeInstructionalMinutes != null &&
                    this.PartTimeInstructionalMinutes.Equals(input.PartTimeInstructionalMinutes))
                ) && 
                (
                    this.PossibleDaysAttendance == input.PossibleDaysAttendance ||
                    (this.PossibleDaysAttendance != null &&
                    this.PossibleDaysAttendance.Equals(input.PossibleDaysAttendance))
                ) && 
                (
                    this.PrivateSchoolChoiceProgramParticipant == input.PrivateSchoolChoiceProgramParticipant ||
                    (this.PrivateSchoolChoiceProgramParticipant != null &&
                    this.PrivateSchoolChoiceProgramParticipant.Equals(input.PrivateSchoolChoiceProgramParticipant))
                ) && 
                (
                    this.ExpectedTransferLocalEducationAgencyReference == input.ExpectedTransferLocalEducationAgencyReference ||
                    (this.ExpectedTransferLocalEducationAgencyReference != null &&
                    this.ExpectedTransferLocalEducationAgencyReference.Equals(input.ExpectedTransferLocalEducationAgencyReference))
                ) && 
                (
                    this.ExpectedTransferSchoolReference == input.ExpectedTransferSchoolReference ||
                    (this.ExpectedTransferSchoolReference != null &&
                    this.ExpectedTransferSchoolReference.Equals(input.ExpectedTransferSchoolReference))
                ) && 
                (
                    this.EnrollmentTypes == input.EnrollmentTypes ||
                    this.EnrollmentTypes != null &&
                    this.EnrollmentTypes.SequenceEqual(input.EnrollmentTypes)
                ) && 
                (
                    this.ReceivingServices == input.ReceivingServices ||
                    this.ReceivingServices != null &&
                    this.ReceivingServices.SequenceEqual(input.ReceivingServices)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.ActualDaysAttendance != null)
                    hashCode = hashCode * 59 + this.ActualDaysAttendance.GetHashCode();
                if (this.CompletedSchoolTerm != null)
                    hashCode = hashCode * 59 + this.CompletedSchoolTerm.GetHashCode();
                if (this.PartTimeInstructionalMinutes != null)
                    hashCode = hashCode * 59 + this.PartTimeInstructionalMinutes.GetHashCode();
                if (this.PossibleDaysAttendance != null)
                    hashCode = hashCode * 59 + this.PossibleDaysAttendance.GetHashCode();
                if (this.PrivateSchoolChoiceProgramParticipant != null)
                    hashCode = hashCode * 59 + this.PrivateSchoolChoiceProgramParticipant.GetHashCode();
                if (this.ExpectedTransferLocalEducationAgencyReference != null)
                    hashCode = hashCode * 59 + this.ExpectedTransferLocalEducationAgencyReference.GetHashCode();
                if (this.ExpectedTransferSchoolReference != null)
                    hashCode = hashCode * 59 + this.ExpectedTransferSchoolReference.GetHashCode();
                if (this.EnrollmentTypes != null)
                    hashCode = hashCode * 59 + this.EnrollmentTypes.GetHashCode();
                if (this.ReceivingServices != null)
                    hashCode = hashCode * 59 + this.ReceivingServices.GetHashCode();
                return hashCode;
            }
        }
    }

}
